=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2006-07-31 21:27:38 +0000
+++ bzrlib/tests/test_sftp_transport.py	2006-07-31 23:04:57 +0000
@@ -293,12 +293,17 @@
 
         self._transport_sftp = bzrlib.transport.sftp
 
-        self.bogus_url = 'sftp://127.0.0.1:1/'
+        # open a random port, so we know nobody else is using it
+        # but don't actually listen on the port.
+        s = socket.socket()
+        s.bind(('localhost', 0))
+        self.bogus_url = 'sftp://%s:%s/' % s.getsockname()
 
         orig_vendor = bzrlib.transport.sftp._ssh_vendor
-        def reset_vendor():
+        def reset():
             bzrlib.transport.sftp._ssh_vendor = orig_vendor
-        self.addCleanup(reset_vendor)
+            s.close()
+        self.addCleanup(reset)
 
     def set_vendor(self, vendor):
         self._transport_sftp._ssh_vendor = vendor

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2006-07-31 22:55:11 +0000
+++ bzrlib/transport/sftp.py	2006-07-31 23:04:57 +0000
@@ -1129,10 +1129,12 @@
 
     def get_bogus_url(self):
         """See bzrlib.transport.Server.get_bogus_url."""
-        # this is chosen to try to prevent trouble with proxies, wierd dns,
-        # etc
-        return 'sftp://127.0.0.1:1/'
-
+        # this is chosen to try to prevent trouble with proxies, wierd dns, etc
+        # we bind a random socket, so that we get a guaranteed unused port
+        # we just never listen on that port
+        s = socket.socket()
+        s.bind(('localhost', 0))
+        return 'sftp://%s:%s/' % s.getsockname()
 
 
 class SFTPFullAbsoluteServer(SFTPServer):

